;---------------------------------------------------------------
; Procedura pro rozpakovani 8 bitu v bytu do 8 bytu
;---------------------------------------------------------------
;
; Volani z C: z_bitbyte(char *buf1, char *buf2, int delka)
; buf1- zpakovane pixly,buf2- rozpakovane,delka- pocet zpakovanych
;
	.MODEL LARGE

_AOFF    EQU  6          ; Offset param. pro LARGE model

CODE SEGMENT
     ASSUME cs:CODE
_z_bitbyte  proc far
	    public _z_bitbyte
;
	    push BP          ; Uschova registru (?AX..DX)
	    mov  BP,SP
	    push DI
	    push SI
	    push DS

	    mov  SI,[BP+_AOFF+0]    ; buf1 -  DS:SI
	    mov  DX,[BP+_AOFF+2]
	    mov  DS,DX

	    mov  DI,[BP+_AOFF+4]    ; buf2 -  ES:DI
	    mov  DX,[BP+_AOFF+6]
	    mov  ES,DX

	    mov  DX,[BP+_AOFF+8]    ; pocet bytu v buf1
	    cld

  Main_cykl:
	    lodsb                   ; DS:SI++ -> AL
	    mov  CX,8
	    cmp  AL,0
	    je   Zopak8
	    cmp  AL,0FFh
	    je   Dej1

	    mov  AH,AL

     Loopx: test AH,80h
	    je   Hop0
	    mov  AL,1
	    jmp  Hop1
      Hop0: mov  AL,0
      Hop1: stosb
	    shl  AH,1
	    loop loopx
	    jmp  Odecti

     Dej1:  mov  AL,1
   Zopak8:  rep  stosb              ; ES:DI++ <- AL (8x)

    Odecti: dec  DX
	    jne  Main_cykl

	    pop  DS
	    pop  SI
	    pop  DI
	    pop  BP
;
	    ret
_z_bitbyte  endp
CODE ENDS
     END
