
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "string1.h"

#include "cfg.h"
#include "define.h"
#include "messages.h"
extern Tcfgblk cfg;

extern char mailmanpath[64];
extern char fwdstr[64];
extern char fwdendstr[64];
extern char mailidxtemplate[128];
extern char replystr[64];
extern char cachepath[64];
extern char binhexstr[];

void uuencode_close(void);
int copyfile(char *s1,char *s);
void putformathtmlstr(char *s,int lf,int testhttp,int wrap);
void fwdputformathtmlstr(FILE*f,char *s,int lf,int quote,int wrap);
char*mime2ext(char*sext,char*mime,char*encoding);
char*ext2mime(char*mime,char*sext);
char*removequotes(char*s);
int decodebase64(char *infile,char *outfile);
char*analyzequotedrow(char*si,int fname);
int geticoname(char *iconame,char *fn,int type,int defi);
char*rel2absdir(char*rs,char*abs);
int getmsgtype(char*fn);
void readheader(FILE*f1,char *fname,Tmsghdr*mhdr,int fast);
void writetitle(Tmsghdr*hdr,char*fn);
void writemsgheader1(Tmsghdr*hdr,char*fn,int box_mode);
void writemsgheader2(Tmsghdr*hdr,char*fn,int box_mode);
void writemsgheader3(Tmsghdr*hdr,char*fn,int box_mode);
void printprevnext(Tmsghdr*hdr,char*fn,int boxtype,char*sprev,char*snext);

typedef struct{char conttype[32];
               char charset[32];
               char filename[32];
               char defaultfilename[32];
	       char encoding[32];
               char boundary[96];
               char description[64];
               int  encodingtype;
               int  usetempfile;
               int  hdrread;
               int  tofile;
               int  eat;
               FILE*f;
               }Tmimehdr;

FILE*uuf;
int isuu=0;
long uurow=0;
int isbinhex=0;
int isimage=0;
int lastzero=0;
int issection=0;
int possiblereturnedmessage=0;
int returnedmessage=0;
int ispre=0;
int hideit=0;
int isattach=0;

#define encoding_plain 0
#define encoding_quoted 1
#define encoding_UU 2
#define encoding_base64 3
#define encoding_binhex 4

#define tmpfilename "$decode$.TMP"

int an=0;//!!glennmcc July 19, 2005 -- count number of attachments

Tmimehdr msgstk[4];
int msgstkptr=0;
int blkcnt=0;
char msgfilename[32];
char encode5bitstr[33]="0123456789ABCDEFGHIJKLMNOPQRSTUV";

void pushmsghdr(Tmimehdr*mhdr){if(msgstkptr>=4)return;memcpy(&msgstk[msgstkptr],mhdr,sizeof(Tmimehdr));msgstkptr++;}
void popmsghdr(Tmimehdr*mhdr){if(!msgstkptr)return;msgstkptr--;if(mhdr)memcpy(mhdr,&msgstk[msgstkptr],sizeof(Tmimehdr));}

void convname2tmpname(char*stgt,int attachnmbr,char*mimetype,char*encoding)
{ char barr[6*8];
  char s[32],*sp;
  unsigned int t,t1,t2,t3;
  memset(s,0,15);memset(barr,0,6*8);
  t3=0;
  xstrncpy(s,msgfilename,8);sp=strchr(s,'.');if(sp)sp[0]=0;
  for(t=0;t<8;t++){t1=(s[t]-'0')&0x0f;
                   for(t2=0;t2<4;t2++){if(t1&0x01)barr[t3]=1;t1>>=1;t3++;}}
  for(t=0;t<8;t++){if(attachnmbr&0x80)barr[t3]=1;attachnmbr<<=1;t3++;}
  memset(s,0,15);
  t1=0;t3=0;
  for(t=0;t<8;t++){t1=0;for(t2=0;t2<5;t2++){t1<<=1;t1|=barr[t3];t3++;}t1&=0x1f;s[t]=encode5bitstr[t1];}
  strcpy(stgt,s);strcat(stgt,".");
  mime2ext(stgt,mimetype,encoding);
  s[1]=t3;
}

void qprintf(char*s)
{ char*sp;
  int n;//,t;
  n=0;
  if(!cfg.quote)sp=s;else
  {sp=s;n=0;while((sp[0]==' ')&&(n<4)){sp++;n++;}
   n=0;
   while(sp[0]=='>'){sp++;n++;}
   n++;if(sp[0]==' ')sp++;}
   //for(t=0;t<n;t++)fprintf(cfg.fexp,">");fprintf(cfg.fexp," ");}
  //fprintf(cfg.fexp,"%s\n",sp);
  //void fwdputformathtmlstr(FILE*f,char *s,int lf,int quote,int wrap)
  fwdputformathtmlstr(cfg.fexp,sp,1,n,1);
}

int fakeerrheader(FILE*f,Tmimehdr*mhdr)
{ char s[256],*sp1;//,*sp2,*sp3,*spp;
  int r;//,t,row;
  fgets(s,255,f);
  memset(mhdr,0,sizeof(Tmimehdr));
  strcpy((*mhdr).encoding,"8BIT");
  strcpy((*mhdr).charset,"US-ASCII");
  strcpy((*mhdr).filename,"");
  strcpy((*mhdr).description,"Returned Message");
  strcpy((*mhdr).boundary,"");
  strcpy((*mhdr).conttype,"MESSAGE/RFC822");
  (*mhdr).hdrread=0;r=0;
  (*mhdr).usetempfile=0;
  convname2tmpname((*mhdr).defaultfilename,blkcnt+1,(*mhdr).conttype,(*mhdr).encoding);
  if(!(*mhdr).filename[0]){sp1=strrchr((*mhdr).defaultfilename,'.');if(sp1){
    if(strcmpi(sp1+1,"TXT"))if(sp1[1])strcpy((*mhdr).filename,(*mhdr).defaultfilename);
   }}
  if((*mhdr).filename[0])(*mhdr).tofile=1;
  sp1=(*mhdr).encoding;
  if(!strcmpi(sp1,"BASE64")){(*mhdr).encodingtype=encoding_base64;(*mhdr).usetempfile=1;}else
  if(!strcmpi(sp1,"QUOTED-PRINTABLE"))(*mhdr).encodingtype=encoding_quoted;else
  {(*mhdr).encodingtype=encoding_plain;}
  return r;
}

int readheaderMIME(FILE*f,Tmimehdr*mhdr)
{ char s[256],*sp1,*sp2;//,*sp3,*spp;
  int t,r,row;
  if(returnedmessage){returnedmessage=0;return fakeerrheader(f,mhdr);}
  memset(mhdr,0,sizeof(Tmimehdr));
  strcpy((*mhdr).encoding,"8BIT");
  strcpy((*mhdr).charset,"US-ASCII");
  strcpy((*mhdr).filename,"");
  strcpy((*mhdr).description,"");
  strcpy((*mhdr).boundary,"");
  strcpy((*mhdr).conttype,"TEXT/PLAIN");
  (*mhdr).hdrread=0;
  (*mhdr).usetempfile=0;
  hideit=0;
  r=0;row=0;
  do{
     s[0]=0;
     fgets(s,255,f);
     strrtrim(s);
     if(!s[0])
      break;
     r++;
     if(s[0]>' ')
      row=0;
     if((!strncmpi(s,"CONTENT-TYPE:",13))||(row==1))
            {if(!row)sp1=s+13;else{sp1=s;s[0]=';';}strtrim(sp1);strcat(sp1,";;;;");(*mhdr).hdrread=1;
             sp2=strchr(sp1,';');sp2[0]=0;sp2++;strtrim(sp1);strtrim(sp2);
             if(!row)xstrncpy((*mhdr).conttype,sp1,32);t=0;row=1;
             while(sp2[0]!=';'){t++;if(t>3)break;
	      sp1=sp2;sp2=strchr(sp1,';');if(!sp2)break;sp2[0]=0;sp2++;strtrim(sp1);strtrim(sp2);
              if(!strncmpi(sp1,"CHARSET=",8))xstrncpy((*mhdr).charset,removequotes(sp1+8),32);else
              if(!strncmpi(sp1,"NAME=",5))xstrncpy((*mhdr).filename,analyzequotedrow(removequotes(sp1+5),1),32);else
              if(!strncmpi(sp1,"BOUNDARY=",9)){xstrncpy((*mhdr).boundary,removequotes(sp1+9),96);}
             }}else
     if((!strncmpi(s,"CONTENT-DISPOSITION:",20))||(row==4))
            {if(!row)sp1=s+20;else{sp1=s;s[0]=';';}strtrim(sp1);strcat(sp1,";;;;");(*mhdr).hdrread=1;
             sp2=strchr(sp1,';');sp2[0]=0;sp2++;strtrim(sp1);strtrim(sp2);
             t=0;row=4;
             while(sp2[0]!=';'){t++;if(t>3)break;
              sp1=sp2;sp2=strchr(sp1,';');if(!sp2)break;sp2[0]=0;sp2++;strtrim(sp1);strtrim(sp2);
              //if(!strncmpi(sp1,"CHARSET=",8))xstrncpy((*mhdr).charset,removequotes(sp1+8),32);else
              if(!(*mhdr).filename[0])if(!strncmpi(sp1,"FILENAME=",9))xstrncpy((*mhdr).filename,analyzequotedrow(removequotes(sp1+9),1),32);//else
	      //if(!strncmpi(sp1,"BOUNDARY=",9)){xstrncpy((*mhdr).boundary,removequotes(sp1+9),96);}
             }}else
     if(!strncmpi(s,"CONTENT-TRANSFER-ENCODING:",26))
            {strcat(s,";");sp1=strchr(s,';');sp1[0]=0;(*mhdr).hdrread=1;row=2;
             xstrncpy((*mhdr).encoding,removequotes(strtrim(s+26)),32);
             }else
     if(!strncmpi(s,"CONTENT-DESCRIPTION:",20))
            {xstrncpy((*mhdr).description,removequotes(strtrim(s+20)),64);(*mhdr).hdrread=1;row=3;
             }else
     {row=0;}
     }while(!feof(f));
  convname2tmpname((*mhdr).defaultfilename,blkcnt+1,(*mhdr).conttype,(*mhdr).encoding);
  if(!(*mhdr).filename[0]){sp1=strrchr((*mhdr).defaultfilename,'.');if(sp1){
    if(strcmpi(sp1+1,"TXT")||!strcmpi((*mhdr).encoding,"BASE64"))
     if(sp1[1])strcpy((*mhdr).filename,(*mhdr).defaultfilename); //else inline
   }}

/*
ASCII differences between c:\arachne\asrc\insight\CONVMSG.C0
                      and c:\arachne\asrc\insight\CONVMSG.C

Replace lines 201-217 in c:\arachne\asrc\insight\CONVMSG.C0
<   if((*mhdr).filename[0])
<   {
<    char *ptr=strrchr(mhdr->filename,'.');
<    if(ptr)
<    {
<     char *ext=ptr;
<     while(ptr>mhdr->filename)
<     {
<      ptr--;
<      if(*ptr=='.' || *ptr<=' ')
<       *ptr='_';
<     }
<     if(ext-(mhdr->filename)>8)
<      memmove(&mhdr->filename[8],ext,5);
<    }
<    (*mhdr).tofile=1;
<   }

with lines 201-226 from c:\arachne\asrc\insight\CONVMSG.C
*/
// BEGIN 2004-07-21 MHT
  {
     int si = 0;                      // filename suffix index
     int i = strlen(mhdr->filename);
     int l = i;
     mhdr->tofile |= i;  // make tofile nonzero if filename not empty
     while (--i >= 0)    // scan filename from right to left
     {
        signed char c = (signed char) mhdr->filename[i];
        if (c == '.')
	   if (!si && i)      // suffix not found yet, and not an initial '.'
              si = i;         // remember suffix position then
           else
              goto und_repl;  // replace invalid '.'
        else if (c <= ' ' ||  // also catches 128..255 thanks to signed char
//!!glennmcc: Feb 27, 2006 -- added the '&' symbol to the list
		 strchr("\"*+,/:;<=>?[\\]|\x7F&", c))
und_repl:
	   mhdr->filename[i] = '_';  // replace other invalid characters
     }
     if (!si)
	si = l;                   // no suffix, make it "" then
     mhdr->filename[si + 4] = 0;  // cut the suffix if too long
     if (si > 8)                  // cut the name if too long
//!!glennmcc: begin July 19, 2005 -- use unique names if more than one LFN
{
 an++;//!!glennmcc: count number of attachments
 if (an<10)
      {
       mhdr->filename[6] = '0';
       itoa(an, &mhdr->filename[7],10);
      }
 else {
       itoa((int)an/10, &mhdr->filename[6],10);
       itoa((int)(an - (((int)an/10)*10)), &mhdr->filename[7],10);
      }
//!!glennmcc: end
	memmove(&mhdr->filename[8], &mhdr->filename[si], 5);
}//!!glennmcc: added for above 'unique name fix'
  }
// END   2004-07-21 MHT

  if(!strncmpi((*mhdr).conttype,"MULTIPART/MIXED",15))(*mhdr).eat=1;
  if(cfg.noout)(*mhdr).eat=1;
  sp1=(*mhdr).encoding;
  if(!strcmpi(sp1,"BASE64")){(*mhdr).encodingtype=encoding_base64;(*mhdr).usetempfile=1;}else
  if(!strcmpi(sp1,"QUOTED-PRINTABLE"))(*mhdr).encodingtype=encoding_quoted;else
  {(*mhdr).encodingtype=encoding_plain;}
  if(!strcmpi((*mhdr).conttype,"multipart/mixed"))hideit=1;else
  if(!strcmpi((*mhdr).conttype,"multipart/report"))hideit=1;else
  if(!strcmpi((*mhdr).conttype,"multipart/digest"))hideit=1;else
  if(!strcmpi((*mhdr).conttype,"multipart/alternative"))hideit=1;
  lastzero=1;
  return r;
}

void printdescription(char*s,int text)
{ if(cfg.reply)return;
  if(!s[0])return;
  if(s[0])
#ifdef SHADDACK
   if(!cfg.sc)
#endif
    printf(cMETA1,"<B><BIG>%s</BIG></B><BR>\n",s);
#ifdef SHADDACK
   else printf("<B><COL=YELLOW>%s</COL></B><BR>\n",s);
#endif
  if(text)printf("<P>\n");
}

void printattachment(char*fname,char*declaredfname,char*encoding,char*mimetype,char*descript)
{
  char s1[10];
  char s[256];
  issection=1;
//  if(descript[0])if(!cfg.sc)printf("<B><BIG>%s</BIG></B><BR>\n",descript);
//                       else printf("<B><COL=YELLOW>%s</COL></B><BR>\n",descript);
  if(cfg.reply){if(cfg.quote)fprintf(cfg.fexp,"> ");
                fprintf(cfg.fexp,cATTF1,declaredfname);
                if(descript[0])fprintf(cfg.fexp," (%s)",descript);fprintf(cfg.fexp,"\n");
                return;}
  printdescription(descript,0);
  isattach=1;
//  if(!cfg.sc)
  if((strncmpi(mimetype,"IMAGE/",6))&&(!cfg.sc))
    {s[0]=0;geticoname(s,fname,0,1);
     if(s[0]){printf("<A HREF=\"file://%s%s\" REMOVABLE><IMG SRC=\"%s\" ALIGN=LEFT BORDER=0 WIDTH=70></A>\n",cachepath,fname,s);}}
//!!glennmcc: Sep 19, 2001...... added for 'ATTACHMENT carry-over' on reply and resend
//  if((box_mode==msg_tbs)||(box_mode==msg_snt))
//  {
//    if((*hdr).attach)
//    {
//!!glennmcc: July 26, 2005 removed from release version till finished
/*
     puts("<INPUT TYPE=HIDDEN NAME=\"attachcheck\" VALUE=\"on\">");
     puts("&nbsp;<INPUT TYPE=CHECKBOX NAME=\"attach\" CHECKED>");
     puts(cREATT);
*/
//!!glennmcc: end July 26, 2005
//    }
//  }
//!!glennmcc: end
  printf(cATTF2);
  s1[0]=0;
#ifdef SHADDACK
  if(cfg.sc)strcpy(s1," FILELINK");
#endif
  if(((strncmpi(mimetype,"IMAGE/",6))||(cfg.sc))&&(cfg.extract))
        printf("<B><A HREF=\"file://%s%s\"%s REMOVABLE>%s</A></B>",cachepath,fname,s1,declaredfname,cMETA);
   else printf("<B>%s</B>",declaredfname);
  printf(cTYPE,mimetype,encoding);
  if((!strncmpi(mimetype,"IMAGE/",6))&&(!cfg.sc))
      {printf("<IMG SRC=\"file://%s%s\"><BR>\n",cachepath,fname);}
}

void processmsgbegin(FILE*f,Tmimehdr*mhdr)
{ char s[256],*sp;
  blkcnt++;isimage=0;
  if(cfg.noout)return;
  if((*mhdr).eat)return;
  if(!cfg.reply)if(ispre)printf("</PRE>");
  if(issection){if(!cfg.reply)printf("<HR>\n");else qprintf("");issection=0;lastzero=1;}

  if(strcmpi(mhdr->charset,"US-ASCII"))
   printf("<META HTTP-EQUIV=\"Content-type\" CONTENT=\"text/html; charset=%s\">",mhdr->charset);

  strcpy(s,(*mhdr).filename);
  mime2ext((*mhdr).filename,(*mhdr).conttype,(*mhdr).encoding);
  if((*mhdr).tofile)printattachment((*mhdr).filename,s,(*mhdr).encoding,(*mhdr).conttype,(*mhdr).description);
               else {if(!cfg.reply)printdescription((*mhdr).description,1);
                     if(!cfg.reply)printf("<PRE><meta http-equiv=\"Content-Type\" content=\"text/html; charset=koi8-r\">");ispre=1;}
  if(!cfg.extract)return;
  if((*mhdr).tofile){strcpy(s,cachepath);sp=strchr(s,0);
                     if((*mhdr).usetempfile)strcpy(sp,tmpfilename);
				       else strcpy(sp,(*mhdr).filename);
		     (*mhdr).f=fopen(s,"wb");
		     if(!(*mhdr).f)
		      {printf(cCANTOF,s,(*mhdr).defaultfilename);
		       printf("<BR>");
		       strcpy(s,cachepath);strcat(s,(*mhdr).defaultfilename);
		       (*mhdr).f=fopen(s,"wb");
		       if(!(*mhdr).f){printf(cSORRY);printf("<BR>");}
		     }}
}

void processmsgend(FILE*f,Tmimehdr*mhdr)
{ char s1[256],s2[256];//,*sp;
  int t;
  if(cfg.reply)return;
  strcpy(s1,cachepath);strcat(s1,tmpfilename);
  strcpy(s2,cachepath);
  strcat(s2,(*mhdr).filename);
  t=0;
  if(cfg.erase){unlink(s2);return;}
  if(!(*mhdr).tofile){if(ispre)if(!cfg.reply)printf(cMETA2);ispre=0;}
  if(!cfg.extract)return;
  if((*mhdr).f){fclose((*mhdr).f);t=1;}
  if((*mhdr).eat)return;
  if((*mhdr).usetempfile)if(t)
   {switch((*mhdr).encodingtype){
     case encoding_base64: printf("<SMALL>");
#ifdef SHADDACK
			   if(cfg.sc)printf("<COL=DKGRAY>");
#endif
			   decodebase64(s1,s2);
#ifdef SHADDACK
			   if(cfg.sc)printf("</COL>");
#endif
			   printf("</SMALL><BR CLEAR=ALL>");isattach=0;break;
     //case encoding_binhex: printf("  <B>BINHEX not implemented yet</B>, cannot decode!\n<BR CLEAR=ALL>\n");break;
   }}
  unlink(s1);
  (*mhdr).usetempfile=0;
  //printf("<BR CLEAR=ALL>\n");
  if(isattach)printf("<BR CLEAR=ALL>");
  isattach=0;
}

void uuencode_open(char*sn,long t,Tmimehdr*mhdr)
{ char s[256],*sp,*sp1;//,s1[256];
  isuu=1;uurow=0;blkcnt++;
  if(isbinhex){convname2tmpname((*mhdr).defaultfilename,blkcnt+1,"application/mac-binhex40","BINHEX");
	       sp=strchr(sn,'\\');if(sp)sp++;else sp=sn;
	       strcpy(sn,(*mhdr).defaultfilename);
	       }
  if(cfg.reply){sprintf(s,cATTF3,sn);
		qprintf(s);qprintf("");return;}
  if(cfg.noout)return;
  sp=strchr(sn,'.');if(sp){sp1=strchr(sp+1,'.');if(sp1)sp1[0]=0;}
  if(ispre)if(!cfg.reply)printf("</PRE>");
  if(issection)printf("<HR>\n");issection=0;lastzero=1;
  ext2mime(s,sn);
  if(!isbinhex)printattachment(sn,sn,"UUENCODE",s,"");
	  else printattachment(sn,sn,"BINHEX",s,"");
  if(!cfg.extract)return;
  strcpy(s,cachepath);if(!isbinhex)strcat(s,tmpfilename);
			      else strcat(s,(*mhdr).defaultfilename);
  uuf=fopen(s,"wa");
  if(!uuf){printf(cNOCREF,s);return;}
  if(!isbinhex)fprintf(uuf,cBEGIN,t,cachepath,sn);
	  else {fprintf(uuf,"%s",binhexstr);fprintf(uuf,"\n");}
}

char uuecount=0;

void uuencode_close()
{
  char s[256];
  char s1[256];
  isuu=0;
  if(cfg.noout)return;
  if(cfg.reply)return;
  if(uuf){if(cfg.extract){if(!isbinhex)
   {fclose(uuf);
    strcpy(s,mailmanpath);strcat(s,"UUDECODE.EXE");
    strcpy(s1,cachepath);strcat(s1,tmpfilename);
//!mp!!!!!!!!!!!
#ifdef SHADDACK
    printf("<SMALL>");
    if(cfg.sc)printf("<COL=DKGRAY>");
    if(spawnl(P_WAIT,s,s,s1,NULL))perror(cNORUNU);
    if(cfg.sc)printf("</COL>");
#else
    {
     FILE *roura2;
     char *mode="at";
     char mman[80];

     if(uuecount==0)
      mode="wt";
     sprintf(mman,"%s$roura2.bat",cachepath);

     roura2=fopen(mman,mode);
     if(roura2)
     {
      char tmp[12];
      sprintf(tmp,"_$uue%d.tmp",uuecount);
      copyfile(tmp,s1);
      sprintf(s1,"@%s %s>uue%d.log\n@del %s\n",s,tmp,uuecount,tmp);
      fprintf(roura2,s1);
      printf(cVUUMES,uuecount++);
      fclose(roura2);
     }
     else
      puts(cCANTADD);
    }
#endif
    printf("</SMALL>");}
   else {fclose(uuf);
	 //printf("BINHEX not implemented yet!");
	 }}
  printf("<BR CLEAR=ALL><HR>");issection=0;isattach=0;
  if(ispre)printf(cMETA3);
}}

void printmsgrow(char*si,Tmimehdr*mhdr)
{ long t;
  char s[256],*sp1,*sp2;
  if(!isuu){
//!!glennmcc: Nov 5, 2000 This will prevent the word "begin" at the
//start of a line from being seen as a UUencoded attachment
   if(!strncmpi(si,"BEGIN 644 ",10))
     {xstrncpy(s,si+6,12);sp1=strchr(s,' ');if(sp1)sp1[0]=0;t=atol(s);if(t){
      sp1=strchr(si,' ');if(sp1){strtrim(sp1);sp1=strchr(sp1,' ');if(sp1)strtrim(sp1);}
      if(!sp1){if(!cfg.noout)printf(cUNKENC);return;}
      sp2=strrchr(sp1,'\\');if(!sp2)sp2=strrchr(sp1,':');if(!sp2)sp2=sp1;else sp2++;
      sp1=strchr(sp2,';');if(sp1)sp1[0]=0;
      isbinhex=0;
      uuencode_open(sp2,t,mhdr);
      }}
    else
      if(!strncmpi(si,binhexstr,strlen(binhexstr)))
       {isbinhex=1;uuencode_open("",0,mhdr);}
   else{if((si[0])||(!lastzero))if(strcmp(si,".")||(!lastzero))
	if(!cfg.noout)if(!hideit){if(!cfg.reply)putformathtmlstr(si,1,1,1);
				  else {qprintf(si);}}
			    else lastzero=1;
	if((si[0])&&(strcmp(si,"."))&&(!hideit)){lastzero=0;issection++;}else lastzero=1;}
   }
  else
   {if(uuf){strtrim(si);fputs(si,uuf);fputs("\n",uuf);uurow++;}
    if(!isbinhex){if(!strcmpi(si,"END"))uuencode_close();}
	     else{if(uurow>1)if(lastchar(si)==':')uuencode_close();}}
}

void handlemsgrow(char*s,Tmimehdr*mhdr)
{ if((*mhdr).encodingtype==encoding_quoted)analyzequotedrow(s,0);
//!!glennmcc: Apr 11, 2006 -- DOS format "\r\n" not UNIX format "\r" alone
  if((*mhdr).f){fputs(s,(*mhdr).f);fputs("\r\n",(*mhdr).f);}
//  if((*mhdr).f){fputs(s,(*mhdr).f);fputs("\n",(*mhdr).f);}
	  else if(!(*mhdr).tofile)printmsgrow(s,mhdr);
}

int processmsgbody(FILE*f,Tmimehdr*mhdr,Tmimehdr*mhdr1)
{ char s[4096];
  int finito;
  char*sp1;//,*sp2;
  finito=0;sp1=strrchr((*mhdr).defaultfilename,'.');
  do{s[0]=0;fgets(s,4096,f);strrtrim(s);
     if(feof(f))finito=1;
     if((*mhdr).boundary[0]){
     if(strncmp(s,(*mhdr).boundary,strlen((*mhdr).boundary))==0)
       {sp1=s+strlen((*mhdr).boundary);
	if(sp1[0]==0)  {return 0;}else
	if(sp1[0]=='-'){return 1;}}else
     if(strncmp(s,"--",2)==0)
      if(strncmp(s+2,(*mhdr).boundary,strlen((*mhdr).boundary))==0)
       {sp1=s+2+strlen((*mhdr).boundary);
	if(sp1[0]==0)  {return 0;}else
	if(sp1[0]=='-'){return 1;}}
     if(msgstkptr>=2)if((*mhdr1).boundary[0]){
     if(strncmp(s,(*mhdr1).boundary,strlen((*mhdr1).boundary))==0)
       {sp1=s+strlen((*mhdr1).boundary);
	if(sp1[0]==0)  {return 0;}else
	if(sp1[0]=='-'){return 1;}}else
     if(strncmp(s,"--",2)==0)
      if(strncmp(s+2,(*mhdr1).boundary,strlen((*mhdr1).boundary))==0)
       {sp1=s+2+strlen((*mhdr1).boundary);
	if(sp1[0]==0)  {return 0;}else
	if(sp1[0]=='-'){return 1;}}
      }}
     if((possiblereturnedmessage)&&(!strcmpi(s,cRETXT))){returnedmessage=1;return 0;}
     if(!(*mhdr).eat)handlemsgrow(s,mhdr);
    }while(!finito);
  return 0;
}

void errmsg(char*s,char*s1,char*s2)
{ if(cfg.noout)return;
  printf(cTITLE);
  printf(cERREAD,s,s1,s2);
}

int convertmessage(char*fnm)
{ char s[256],*sp1,sprev[128],snext[128];//,*sp2;
  FILE*f;
  Tmimehdr mhdr,mhdr1;
  Tmsghdr msghdr;
  int msgtype;
  int t;
  int loopcnt;
  char fname[256];
  xstrncpy(fname,fnm,128);sprev[0]=0;snext[0]=0;
  rel2absdir(fname,mailmanpath);
  sp1=strrchr(fname,'\\');if(!sp1)sp1=strrchr(fname,':');if(!sp1)sp1=fname;else sp1++;
  xstrncpy(msgfilename,sp1,15);
  //we won't delete attachments from cache...
  msgtype=getmsgtype(fname);
  if(cfg.erase)
  {
   printprevnext(&msghdr,fname,msgtype,sprev,snext);
   //unlink(fname);
   return 1;
  }
  f=fopen(fname,"rb");
  if(!f){errmsg(cCANTOF1,fname, cABORTING);
	 return 0;}
  if(!cfg.reply)
   {readheader(f,fname,&msghdr,0);
    if(msghdr.subj)if(!strcmpi(msghdr.subj,cWARN))possiblereturnedmessage=1;
/*
!mp!!!!!!!! tohle k nicemu nepotrebuju, viz F6 - page source
    if(!cfg.noout)if(!cfg.sc){puts("<!-- Original header");copymsgheader(f);puts("-->");}
*/
//    msgtype=getmsgtype(fname);
    if(!cfg.noout)writetitle(&msghdr,fname);
    if(!cfg.noout)writemsgheader1(&msghdr,fname,msgtype);
    printprevnext(&msghdr,fname,msgtype,sprev,snext);

    if(!cfg.noout)writemsgheader2(&msghdr,fname,msgtype);
    if(!cfg.noout)writemsgheader3(&msghdr,fname,msgtype);}
  rewind(f);
  memset(&mhdr,0,sizeof(Tmimehdr));memset(&mhdr1,0,sizeof(Tmimehdr));
  loopcnt=0;
  pushmsghdr(&mhdr);
  s[0]=0;
  do{ if(mhdr.boundary[0])xstrncpy(s,mhdr.boundary,255);
      readheaderMIME(f,&mhdr);
      loopcnt++;
      if(mhdr.boundary[0]){popmsghdr(&mhdr1);pushmsghdr(&mhdr1);pushmsghdr(&mhdr);}
		      else xstrncpy(mhdr.boundary,s,95);
      {if(!hideit)processmsgbegin(f,&mhdr);
       t=processmsgbody(f,&mhdr,&mhdr1);
       if(!hideit)processmsgend(f,&mhdr);
       if(t)popmsghdr(&mhdr);
    }}while(!feof(f));
  fclose(f);
//  if(cfg.erase){unlink(fname);return 1;}
  if(cfg.reply)return 1;
  if(isattach)printf("<BR CLEAR=ALL>");
  if(issection){printf("<HR>");}
  if(ispre)printf("</PRE>");
  PRINTVER;
  return 1;
}