
#include <stdio.h>
#include <dir.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "string1.h"

#include "messages.h"

typedef union{char s[8];unsigned long l[2];int i[4];}Tcharlong;
typedef struct{int n;Tcharlong order;}Tsortstruct;

#define maxsortarr 4000L
typedef Tsortstruct Tsortarr[maxsortarr];
//#define idxfilename "$idx$cnm.idx"
//#define idxsortfilename "$srt$cnm.idx"

#include "define.h"

#include "tidx.h"
// RAY
//extern char boxname[5][14];
extern char *boxname[5];
// Whenever you change the meaning of an identifier, you must search
// the whole code to make sure that all uses of the identifier are
// changed!  Usualy the compiler will give you an error message, but
// sometimes not :-(

extern char boxdginame[5][14];
extern char extname[5][10];
extern char mailidxtemplate[128];
extern int inifileread;
// RAY
//extern char nosubjstr[32];

int mailsortorder=sortorder_rcv;

void readarachneinifile(void);
void puthtmlchar(char c);
char*removequotes(char*s);
void puthtmlstr(char *s,int lf);
void readarachneinifile();
void setidxtemplatedefault();
int getmsgtype(char*fn);
void readheader(FILE*f1,char *fname,Tmsghdr*mhdr,int fast);
char*nostr(char*s,char*def);


#define s_head 1
#define s_idxrow 2
#define s_tail 3
#define s_tail1st 4
#define s_empty 5

void setidxtemplatedefault(void);

char*getvariablename(char*s,char*sfmt,char*ssrc)
{ char*sp,*sp1;char xc;
  s[0]=0;
  sp=strchr(ssrc+1,'$');if(!sp)return ssrc+1;
  xc=sp[0];sp[0]=0;
  xstrncpy(s,ssrc+1,16);
  sp1=strchr(s,':');if(!sp1)sfmt[0]=0;
   else{sp1[0]=0;sp1++;xstrncpy(sfmt,sp1,6);}
  strupr(s);
  sp[0]=xc;
  if(sp-ssrc>16)return s+1;
  return sp+1;
}

char*convaddrstr(char*s)
{ char*sp1;//,*sp2;
  strtrim(s);
  sp1=strchr(s,'<');
  if(sp1)if(sp1>s+2){sp1[0]=0;strtrim(s);}
  removequotes(s);return s;
}

char*convdatestr(char*s)
{ char*sp1;
  sp1=strchr(s,':');if(!sp1)return s;if(sp1<s+12)return s;
  sp1[0]=0;sp1=strrchr(s,' ');if(sp1)sp1[0]=0;return s;
}

void printfs(char*s,int fmtlen)
{ if(fmtlen)s[fmtlen]=0;
  printf("%s",s);
}

void cstrtp(char*s,char c)
{ char*sp;
  sp=strchr(s,0);if(lastchar(s)=='s')sp--;
  sp[0]=c;sp[1]=0;
}

void putidxrow(char*s,Tidx*idx,Tidxinfo*idxinfo,int msgcnt)
{ int fromto;
  char sn[128],sft[32],sw[32];char*sp;int fmtlen;
  sp=rightstr((*idxinfo).mboxfspec,4);
  if(!strcmpi(sp,".TBS"))fromto=0;else
  if(!strcmpi(sp,".SNT"))fromto=0;else
			 fromto=1;
  while(s[0]){
   if(s[0]=='$'){s=getvariablename(sn,sft,s);
		 sp=strchr(sft,':');if(!sp)fmtlen=0;else{sp[0]=0;sp++;fmtlen=atoi(sp);}
		 strcpy(sw,"%");if(sft[0])strcat(sw,sft);else strcat(sw,"s");
		 if(fmtlen<0)fmtlen=0;else if(fmtlen>127)fmtlen=127;
		 if(!strcmp(sn,"VERSION"    )){sprintf(sn,sw,versionstr);}else
//!!glennmcc: Apr 13, 2005 -- use all lower case for path\filename
//!!glennmcc: Nov 18, 2005 -- use all UPPER case for path\filename
		 if(!strcmp(sn,"FILENAME"   )){sprintf(sn,"%s%s",strupr((*idxinfo).mboxpath),strupr((*idx).fn));}else
//               if(!strcmp(sn,"FILENAME"   )){sprintf(sn,"%s%s",(*idxinfo).mboxpath,(*idx).fn);}else
		 if(!strcmp(sn,"MSGDATE"    )){sprintf(sn,sw,convdatestr((*idx).date));}else
//!!glennmcc: Nov 18, 2005 -- truncate subject to 78 characters
//(for display only......
// the entire line will be retained for any reply or forward)
//!!glennmcc: Mar 06, 2006 -- reversed the change,
// now back to original display length of 127
// cgiquery.c in core.exe SRC now limits compose,
// reply, resend and forward to 255
//		 if(!strcmp(sn,"MSGSUBJ"    )){sprintf(sn,sw,xstrncpy((*idx).subj,(*idx).subj,78));}else
		 if(!strcmp(sn,"MSGSUBJ"    )){sprintf(sn,sw,(*idx).subj);}else
		 if(!strcmp(sn,"MSGSIZE"    )){sprintf(sn,"%li.%03li",(*idx).filesize/1000,(*idx).filesize%1000);}else
		 if(!strcmp(sn,"MSGCNT"     )){cstrtp(sw,'i');sprintf(sn,sw,msgcnt);}else
		 if(!strcmp(sn,"MSGTOTCNT"  )){cstrtp(sw,'i');sprintf(sn,sw,(*idxinfo).totcnt);}else
		 if(!strcmp(sn,"MSGTOTSIZE" )){sprintf(sn,"%li.%03li",(*idxinfo).totsize/1000,(*idxinfo).totsize%1000);}else
//!!glennmcc: Apr 13, 2005 -- use all lower case for path\filename
		 if(!strcmp(sn,"FILESPEC"   )){sprintf(sn,"%s%s",strlwr((*idxinfo).mboxpath),strlwr((*idxinfo).mboxfspec));}else
//               if(!strcmp(sn,"FILESPEC"   )){sprintf(sn,"%s%s",(*idxinfo).mboxpath,(*idxinfo).mboxfspec);}else
		 if(!strcmp(sn,"FROMTO"     )){if(fromto)sprintf(sn,sw,cFROM);else sprintf(sn,sw,cTO);}else
//                 if(!strcmp(sn,"FROMTO"     )){if(fromto)sprintf(sn,sw,"From");else sprintf(sn,sw,"To");}else
		 if(!strcmp(sn,"MSGFROMTO"  )){if(fromto)sprintf(sn,sw,convaddrstr((*idx).from));else sprintf(sn,sw,convaddrstr((*idx).to));}else
		 if(!strcmp(sn,"BOXNAME"    ))
		 {
		  if((*idxinfo).mboxtype%5==2)
		  {
		   char boxname[64],*ptr;
		   strncpy(boxname,(*idxinfo).mboxpath,63);
		   boxname[63]='\0';
		   ptr=strrchr(boxname,'\\');
		   if(ptr)
		   {
		    *ptr='\0';
		    ptr=strrchr(boxname,'\\');
		   }
		   if(ptr)
		    ptr++;
		   else
		    ptr=boxname;
		   sprintf(sn,sw,ptr);
		  }
		  else
		   sprintf(sn,sw,boxname[(*idxinfo).mboxtype%5]);
		 }else
		 sprintf(sn,"$%s$",sn);
		 if(fmtlen)sn[fmtlen]=0;//printf("%s",sn);
		 puthtmlstr(sn,0);
		}
   else {putchar(s[0]);s++;}
  }
  putchar(0x0d);putchar(0x0a);
}

void erridx(char*s,char*s1,char*s2)
{ printf(cMIERRT);
  printf(cMIERRH,s,s1,s2);
}

#define MAXIDXROW 2048

void printidx(FILE *fidx,Tsortarr*sarr,Tidxinfo*idxinfo)
{ int t;//,t1;
  Tidx idx;
  FILE *f;
  char s[256];
//  char s1[128];
  char stpl[MAXIDXROW];
  char empty[MAXIDXROW];
//  char*sp;
  int stype;
//  strcpy(s,mailmanpath);
//  if(!cfg.sc)strcat(s,idxtemplatename);
//        else strcat(s,idxsctemplatename);
  stype=0;
  stpl[0]=0;
  empty[0]=0;
//!!glennmcc: Jan 22, 2005 -- also use default if more than 256 messages
//deafult changed to idxfast.htp over in inifile.c
  f=fopen(mailidxtemplate,"rb");if(!f || (*idxinfo).totcnt>256)
//f=fopen(mailidxtemplate,"rb");if(!f)
//!!glennmcc: no message needed .... just do it ;-)
  {
//printf("<I>     <B>\"%s\"</B>,    .</I><P>\n",mailidxtemplate);
    setidxtemplatedefault();
    f=fopen(mailidxtemplate,"rb");if(!f){erridx(cCNNOIT,mailidxtemplate, cABORTING);return;}}

  do{s[0]=0;
     fgets(s,255,f);
     strtrim(s);
     if(!s[0])continue;
     if(s[0]=='#'){
       if(!strcmpi(s,"#HEAD")){stype=s_head;continue;}else
       if(!strcmpi(s,"#TAIL")){stype=s_tail1st;continue;}else
       if(!strcmpi(s,"#EMPTY")){stype=s_empty;continue;}else
       if(!strcmpi(s,"#IDXROW")){stype=s_idxrow;continue;}}else
      if(stype==s_idxrow)
      {
       if(strlen(stpl)<MAXIDXROW)
       {
	strcat(stpl,s);
	strcat(stpl,"\r\n");
       }
      }
      else
      if(stype==s_empty)
      {
       if(strlen(empty)<MAXIDXROW)
       {
	strcat(empty,s);
	strcat(empty,"\r\n");
       }
      }
      else
      if(stype==s_tail1st){for(t=0;t<(*idxinfo).totcnt;t++)
//!!glennmcc: Jan 21, 2006 -- break if too many items
//    if(t>2000) continue; else
//!!glennmcc: end
			    {fseek(fidx,(long)sizeof(Tidx)*(long)(*sarr)[t].n,SEEK_SET);
			     memset(&idx,0,sizeof(idx));
			     fread(&idx,1,sizeof(idx),fidx);
			     //printf("%08lx,%08lx %s\n",(*sarr)[t].order.l[0],(*sarr)[t].order.l[1],idx.date);
			     putidxrow(stpl,&idx,idxinfo,t+1);
			     }
			   if(t==0)
			    putidxrow(empty,&idx,idxinfo,0);
			   putidxrow(s,&idx,idxinfo,0);
			   stype=s_tail;}else
	   putidxrow(s,&idx,idxinfo,0);
  }while(!feof(f));
//!!glennmcc: Jan 21, 2006 -- break if too many items
//    if(t>2000)
//    printf("<br><br><b>Ugh! Unbelievably large directory.<br>"
//    "Only listing the first %d of %d items.</b>",(MAXIDXROW-48),(*idxinfo).totcnt);
//!!glennmcc: end
  fclose(f);
}
void sortidxarr(Tsortarr*sarr,int sarrcnt,FILE*fidx)
{// Tidx idx1,idx2;
  Tsortstruct ss;
  int t,t1;
  do{t1=0;
     for(t=0;t<sarrcnt-1;t++)
      if(((*sarr)[t].order.l[0]>(*sarr)[t+1].order.l[0])
        ||(((*sarr)[t].order.l[0]==(*sarr)[t+1].order.l[0]) && ((*sarr)[t].order.l[1]>(*sarr)[t+1].order.l[1])))
       {t1=1;
        memcpy(&ss,&(*sarr)[t],sizeof(Tsortstruct));
        memcpy(&(*sarr)[t],&(*sarr)[t+1],sizeof(Tsortstruct));
        memcpy(&(*sarr)[t+1],&ss,sizeof(Tsortstruct));}
    }while(t1);
}

/*void packstring(char*st,char*ss,int n)
{ char s[256];
  int t,t1,t2,t3;
  n=min(n,16);
  memset(s,0,255);t3=0;
  memset(st,0,n);
  for(t1=0;t1<min(strlen(ss),16);t1++)
   {t=toupper(ss[t1]);t&=0x7f;t-=0x20;if(t>0x3f)t=0x3f;else if(t<=0)t=1;
    for(t2=0;t2<6;t2++){if(t&0x01)s[t3]=1;t>>=1;t3++;}}
  t3=0;
  for(t1=0;t1<n;t1++)
   {t=0;for(t2=0;t2<8;t2++){t<<=1;if(s[t3])t|=0x01;t3++;}st[t1]=t;}
}/**/

void packstring(char*st,char*ss,int n)
{ int t;
  memset(st,n,0);strncpy(st,ss,n);for(t=0;t<n;t++)st[t]=toupper(st[t]);
}

#define maxmprefix 8
char mprefix[maxmprefix][11]={"FORWARDED:","(FWD)","FWD:","FW:","RE:","RE","FWD","FW"};

int adjustsubjstr(char*s)
{ int r,r1,t;
  char*sp1;//,*sp2;
  r=0;
  sp1=s;
  do{r1=0;
     for(t=0;t<maxmprefix;t++)if(!strncmpi(sp1,mprefix[t],strlen(mprefix[t])))
       {sp1+=strlen(mprefix[t]);strtrim(sp1);r1++;r++;}
     }while(r1);
  if(sp1!=s)memmove(s,sp1,strlen(sp1)+1);
  return r;
}

//Date: Thu, 9 Oct 1997 11:50:16 +0100 (MET)
char montharr[13][4]={"---","Jan","Feb","Mar","Apr","May","Jun",
                            "Jul","Aug","Sep","Oct","Nov","Dec"};


// char montharr[13][7]={"---",".",".","",".","","",
//                             "",".",".",".",".","."};

int month2int(char*s)
{ int res;
  res=atoi(s);if((res)&&(res<13))return res;
  for(res=1;res<13;res++)if(!strncmpi(s,montharr[res],3))return res;
  return 0;
}

void strdate2int(char*s,unsigned int*id,unsigned int*it)
{ char*sp,*sp1,*sp2,*sp3;//,*sp4;
  int day,month,year,hr,min,sec;
  (*id)=0;(*it)=0;
  sp=strchr(s,',');if(!sp)return;
  sp++;strtrim(sp);
  sp1=strchr(sp ,' ');if(!sp1)return;sp1[0]=0;sp1++;strtrim(sp1);
  sp2=strchr(sp1,' ');if(!sp2)return;sp2[0]=0;sp2++;strtrim(sp2);
  sp3=strchr(sp2,' ');if(!sp3)return;sp3[0]=0;sp3++;strtrim(sp3);
  day=atoi(sp);month=month2int(sp1);year=atoi(sp2);
  if(year>1980)year-=1980;
  else if(year>80)year-=80;else if(year<20)year+=20;
  day&=0x1f;month&=0x0f;year&=0x7f;
  (*id)=day+(month<<5)+(year<<9);
  //printf("--- %i.%i.%i\n",day,month,year);
  sp=sp3;
  sp1=strchr(sp ,':');if(!sp1)return;sp1[0]=0;sp1++;strtrim(sp1);
  hr=atoi(sp);(*it)=((hr&0x1f)<<11);
  sp2=strchr(sp1,':');if(!sp2){sp2=strchr(sp1,' ');if(sp2)sp2[0]=0;min=atoi(sp1);(*it)+=((min&0x3f)<<5);return;}
  sp2[0]=0;sp2++;strtrim(sp2);
  sp3=strchr(sp2,' ');if(sp3)sp3[0]=0;
  min=atoi(sp1)&0x3f;sec=(atoi(sp2)>>1)&0x1f;
  (*it)+=(min<<5)+sec;
  //printf("--- %i.%i.%i\n",hr,min,sec);
}

void getidxarrvalue(Tcharlong*itgt,Tidx*idx,int sord)
{ char*sp,*tgt;
  char s[64];
  int t;//,t1;
  unsigned int td,tt;
  tgt=(*itgt).s;
  memset(tgt,0,8);
  switch(sord)
   {case sortorder_snt: strdate2int((char*)(*idx).date,&td,&tt);
                        (*itgt).i[1]=td;(*itgt).i[0]=tt;
                        memcpy(s,tgt,4);swab(tgt,s,4);
                        break;
    case sortorder_rcv: (*itgt).i[1]=(*idx).fdate;
                        (*itgt).i[0]=(*idx).ftime;
                        memcpy(s,tgt,4);
                        swab(tgt,s,4);
                        break;
    case sortorder_addr:xstrncpy(s,(*idx).from,32);
                        sp=(*idx).from;if(sp[0]=='"')sp++;if(sp[0]=='<')sp++;
                        packstring(s,sp,8);
                        strtrim(s);sp=s;
                        tgt[0]=sp[3];tgt[1]=sp[2];tgt[2]=sp[1];tgt[3]=sp[0];
                        tgt[4]=sp[7];tgt[5]=sp[6];tgt[6]=sp[5];tgt[7]=sp[4];
                        break;
    case sortorder_subj:xstrncpy(s,(*idx).subj,32);
                        strtrim(s);//sp=s;
                        //if(!strncmpi(sp,"FWD:",4)){sp+=4;strtrim(sp);}
                        //if(!strncmpi(sp,"RE:" ,3)){sp+=3;strtrim(sp);}
                        //if(!strncmpi(sp,"RE:" ,3)){sp+=3;strtrim(sp);}
                        packstring(s,(*idx).subj,8);
                        t=adjustsubjstr(s);
                        tgt[0]=s[3];tgt[1]=s[2];tgt[2]=s[1];tgt[3]=s[0];
                        tgt[4]=s[7]+t;tgt[5]=s[6];tgt[6]=s[5];tgt[7]=s[4];
                        break;
   }
}

char*adjustaddrstr(char*s)
{ char*sp1,*sp2,*sp3;
  sp1=strchr(s,' ');sp3=sp1;if(sp1)sp3=strchr(sp1+1,' ');
  if(sp3){sp2=strchr(sp3,'<');if(sp2){sp2[0]=0;strtrim(s);}}
  return s;
}

void readmaildir(char*spath)
{ struct ffblk ff;
  FILE *fidx;
  Tsortarr*sarr;
  Tidxinfo idxinfo;
//  char idxfilename[16];
  unsigned long sarrcnt,res,t;
  char s[256],*sp;
  Tmsghdr msghdr;
  Tidx idx;
  if(!inifileread)readarachneinifile();
  sarr=(Tsortarr*)calloc(1,sizeof(Tsortarr));
  if(!sarr){puts(cCNNTAM);return;}
  memset(sarr,0,sizeof(Tsortarr));sarrcnt=0;memset(&idxinfo,0,sizeof(idxinfo));
  strcpy(s,spath);sp=strrchr(s,'\\');if(!sp)sp=strrchr(s,':');if(sp)sp++;else sp=s;
  strupr(s);xstrncpy(idxinfo.mboxfspec,sp,15);
  idxinfo.mboxtype=getmsgtype(spath);
  if(idxinfo.mboxtype%5!=2) //received mail
   printf("<BASE HREF=file://%s>\n",boxdginame[idxinfo.mboxtype%5]);
  sp[0]=0;xstrncpy(idxinfo.mboxpath,s,63);
  //strcpy(sp,idxfilename);
  //!mp:pouze uprava ladiciho tisku:
  strcpy(sp,"$IDX$");strcat(sp,extname[idxinfo.mboxtype%5]);strcat(sp,".IDX");
  {
   char path[80];
   if(idxinfo.mboxtype%5==msg_cnm)
   {
//  puts("!!!!!!!!!!!");
    detidxpath(path,"IDX",extname[idxinfo.mboxtype%5]);
   }
   else
   {
//  puts("???????????");
    strncpy(path,s,79);
    path[79]='\0';
   }
   fidx=fopen(path,"wb+");if(!fidx){printf(cCNNTCFI,path);free(sarr);return;}
  }
  //!mp:end
  res=findfirst(spath,&ff,0xff);
  while(!res){xstrncpy(sp,ff.ff_name,14);
              readheader(NULL,s,&msghdr,1);memset(&idx,0,sizeof(idx));
              xstrncpy(idx.fn,sp,14);
              idx.fdate=ff.ff_fdate;idx.ftime=ff.ff_ftime;
              xstrncpy(idx.from,adjustaddrstr(nostr(msghdr.from,"")),63);
              xstrncpy(idx.to  ,adjustaddrstr(nostr(msghdr.to  ,"")),63);
              xstrncpy(idx.subj,nostr(msghdr.subj,""),127);
              xstrncpy(idx.date,nostr(msghdr.date,""),63);
// RAY
//              if(!idx.subj[0])strcpy(idx.subj,nosubjstr);
if(!idx.subj[0])strcpy(idx.subj,cNOSUBJ);
              idx.filesize=msghdr.filesize;
              idxinfo.totsize+=idx.filesize;
              fwrite(&idx,sizeof(idx),1,fidx);
              (*sarr)[sarrcnt].n=sarrcnt;
              getidxarrvalue(&(*sarr)[sarrcnt].order,&idx,mailsortorder);
              sarrcnt++;
              res=findnext(&ff);
             }
  idxinfo.totcnt=sarrcnt;
  sortidxarr(sarr,sarrcnt,fidx);
  printidx(fidx,sarr,&idxinfo);
  fclose(fidx);
  //
  strcpy(s,spath);sp=strrchr(s,'\\');if(!sp)sp=strrchr(s,':');if(sp)sp++;else sp=s;
  strupr(s);sp[0]=0;
  //strcpy(sp,idxfilename);
  strcpy(sp,"$SRT$");strcat(sp,extname[idxinfo.mboxtype%5]);strcat(sp,".IDX");
  {
   char path[80];
   if(idxinfo.mboxtype%5==msg_cnm)
    detidxpath(path,"SRT",extname[idxinfo.mboxtype%5]);
   else
   {
    strncpy(path,s,79);
    path[79]='\0';
   }
   fidx=fopen(path,"wb");if(!fidx){puts(cCNNTCFIS);free(sarr);return;}
  }
  for(t=0;t<sarrcnt;t++)fwrite(&((*sarr)[t].n),2,1,fidx);
  fclose(fidx);
  //
 free(sarr);
}